#include "graphic_functions.h"

void* GetVRAMAdress()
{
	asm("mov.l syscall_adress, r2");
	asm("mov.l getVRAM, r0");
	asm("jmp @r2");
	asm("nop");
	asm("syscall_adress: .long 0x80020070");
	asm("getVRAM: .long 0x01E6");
}

void vertical_scroll()
{
	int x, y, max_y;
	short* VRAM = GetVRAMAdress();
	for(y=0 ; y<LCD_HEIGHT_PX-8*3 ; y++) {
		for(x=0 ; x<LCD_WIDTH_PX ; x++)
			VRAM[y*LCD_WIDTH_PX+x] = VRAM[(y+8*3)*LCD_WIDTH_PX+x];
	}
}

void draw_pixelX3(int x, int y)
{
	int i, j;
	if(x&~127 || y&~63) return;
	short* VRAM = GetVRAMAdress();
	for(i=0 ; i<3 ; i++) {
		for(j=0 ; j<3 ; j++) {
			VRAM[LCD_WIDTH_PX*(3*y+i) + 3*x+j] = 0x0000;
		}
	}
}

void draw_bmp(unsigned char *bmp, int x, int y, int width, int height)
{
	int i, j, byte_width;
	byte_width = ((width-1)>>3)+1;
	for(i=0 ; i<height ; i++) {
		for(j=0 ; j<width ; j++) {
			if(bmp[i*byte_width+(j>>3)] & 128>>(j&7))
				draw_pixelX3(x+j, y+i);
		}
	}
}